>From 45c0928847db27acf57a7f88c84fcf9371d3fb8e Mon Sep 17 00:00:00 2001
From: Henne Vogelsang <hvogel@opensuse.org>
Date: Tue, 27 Jul 2010 12:55:17 +0200
Subject: [PATCH] fix links that point to the wiki


Signed-off-by: Henne Vogelsang <hvogel@opensuse.org>
---
 ReleaseNotes-1.5                                   |    2 +-
 ReleaseNotes-2.0                                   |    8 ++++----
 dist/README.SETUP                                  |    2 +-
 dist/obs-server.spec                               |    2 +-
 dist/obsapisetup                                   |    2 +-
 docs/mockup/buildservice/project-old.html          |    2 +-
 docs/mockup/buildservice/project.html              |    2 +-
 documentation/books/en/xml/concept_overview.xml    |    4 ++--
 documentation/books/en/xml/glossary.xml            |    2 +-
 documentation/books/en/xml/kiwi_introduction.xml   |    2 +-
 .../books/en/xml/project_dependencies.xml          |    2 +-
 documentation/books/en/xml/webclient_example.xml   |   12 ++++++------
 src/api/lib/wizard.rb                              |    2 +-
 .../openSUSE/openSUSE11.0.product                  |    2 +-
 .../products/product.sle11-sles.xml                |    2 +-
 src/webui/README.install                           |    2 +-
 src/webui/app/views/driver_update/create.html.erb  |    2 +-
 src/webui/app/views/main/about.rhtml               |    2 +-
 src/webui/app/views/main/index.rhtml               |    8 ++++----
 src/webui/app/views/package/show.html.erb          |    2 +-
 src/webui/app/views/user/request_ichain.rhtml      |    2 +-
 .../views/vendor/bento/layouts/_header.html.erb    |    8 ++++----
 .../vendor/bento/layouts/application.html.erb      |   10 +++++-----
 23 files changed, 42 insertions(+), 42 deletions(-)

diff --git a/ReleaseNotes-1.5 b/ReleaseNotes-1.5
index 78a4899..62319fa 100644
--- a/ReleaseNotes-1.5
+++ b/ReleaseNotes-1.5
@@ -9,7 +9,7 @@ README.UPDATE has informations for updaters.
 
 Main new features are:
  * Product Build Support
-   http://en.opensuse.org/Build_Service/Concepts/Product_Definition
+   http://en.opensuse.org/openSUSE:Build_Service_Concept_Product_Definition
 
  * kiwi based image building in general
 
diff --git a/ReleaseNotes-2.0 b/ReleaseNotes-2.0
index 3208eb2..e482e85 100644
--- a/ReleaseNotes-2.0
+++ b/ReleaseNotes-2.0
@@ -5,7 +5,7 @@
 Please read the README.SETUP file for initial installation
 instructions or use the OBS Appliance from
 
-  http://en.opensuse.org/Build_Service/OBS-Appliance
+  http://en.opensuse.org/openSUSE:Build_Service_Appliance
 
 README.UPDATERS file has informations for updaters.
 
@@ -52,17 +52,17 @@ Features:
   - Review mechanism
     - New "reviewer" role to set default reviewers for a package or project.
       These can be users or groups.
-    http://en.opensuse.org/Build_Service/Concepts/Review
+    http://en.opensuse.org/openSUSE:Build_Service_Concept_Review
 
   - New requests types for
     - set bugowner
     - add role
 
 * Project link mechanism
-  http://en.opensuse.org/Build_Service/Concepts/ProjectLinking
+  http://en.opensuse.org/openSUSE:Build_Service_Concept_project_linking
 
 * Build job scheduling strategies got configurable
-  http://en.opensuse.org/Build_Service/Concepts/BuildSchedulingStrategies
+  http://en.opensuse.org/openSUSE:Build_Service_Concept_build_scheduling_strategies
 
 * New fair build job dispatcher is distributing the jobs based on importance
   and former used build times now.
diff --git a/dist/README.SETUP b/dist/README.SETUP
index 352c24c..b1a7ad6 100644
--- a/dist/README.SETUP
+++ b/dist/README.SETUP
@@ -7,7 +7,7 @@ this is possible.
 An easier way to run OBS is via using the OBS Appliance. It is also 
 usable for a production server. Please find details here:
 
-   http://wiki.opensuse.org/openSUSE:Build_Service_Appliance
+   http://en.opensuse.org/openSUSE:Build_Service_Appliance
 
 1. run the backend
 ==================
diff --git a/dist/obs-server.spec b/dist/obs-server.spec
index 01e3c4d..a666c61 100644
--- a/dist/obs-server.spec
+++ b/dist/obs-server.spec
@@ -17,7 +17,7 @@ Version:        1.9.62
 Release:        0
 License:        GPL
 Group:          Productivity/Networking/Web/Utilities
-Url:            http://en.opensuse.org/Build_Service
+Url:            http://en.opensuse.org/Portal:Build_Service
 BuildRoot:      /var/tmp/%name-root
 # git clone git://gitorious.org/opensuse/build-service.git build-service-1.7.54; tar cfvj obs-server-1.7.54.tar.bz2 --exclude=.git\* build-service-1.7.54/
 Source:         obs-server-%version.tar.bz2
diff --git a/dist/obsapisetup b/dist/obsapisetup
index d152de4..62760be 100755
--- a/dist/obsapisetup
+++ b/dist/obsapisetup
@@ -113,7 +113,7 @@ EOF
 
 More informations about this appliance are available here:
 
- http://en.opensuse.org/Build_Service/OBS-Appliance
+ http://en.opensuse.org/openSUSE:Build_Service_Appliance
 
                                   Greetings from the openSUSE Build Service Team
 
diff --git a/docs/mockup/buildservice/project-old.html b/docs/mockup/buildservice/project-old.html
index 6deb93a..86e1e47 100644
--- a/docs/mockup/buildservice/project-old.html
+++ b/docs/mockup/buildservice/project-old.html
@@ -253,7 +253,7 @@
 
         <div id="footer">
             openSUSE and SUSE are trademarks of Novell, Inc. in the United States and other countries.<br>
-            <a href="http://en.opensuse.org/Legal">Legal Information</a> | <a href="mailto:webmaster@opensuse.org">Feedback</a>
+            <a href="http://en.opensuse.org/Terms_of_site">Legal Information</a> | <a href="mailto:webmaster@opensuse.org">Feedback</a>
         </div>
     </body>
 
diff --git a/docs/mockup/buildservice/project.html b/docs/mockup/buildservice/project.html
index 4e543e5..0bbb0a4 100644
--- a/docs/mockup/buildservice/project.html
+++ b/docs/mockup/buildservice/project.html
@@ -253,7 +253,7 @@
 
     <div id="footer">
         openSUSE and SUSE are trademarks of Novell, Inc. in the United States and other countries.<br>
-        <a href="http://en.opensuse.org/Legal">Legal Information</a> | <a href="mailto:webmaster@opensuse.org">Feedback</a>
+        <a href="http://en.opensuse.org/Terms_of_site">Legal Information</a> | <a href="mailto:webmaster@opensuse.org">Feedback</a>
     </div>
 </body>
 
diff --git a/documentation/books/en/xml/concept_overview.xml b/documentation/books/en/xml/concept_overview.xml
index 8930a62..d76588b 100644
--- a/documentation/books/en/xml/concept_overview.xml
+++ b/documentation/books/en/xml/concept_overview.xml
@@ -49,8 +49,8 @@
    have a trust management for users and projects. It is also planned to offer
    the build of flavors of distributions, such as openSUSE for XEN, Live DVDs,
    and others. More information on planned features are availabe at <ulink
-    url="http://en.opensuse.org/Build_Service/Future_Ideas"/> and <ulink
-    url="http://en.opensuse.org/Build_Service/Roadmap"/>.
+    url="https://features.opensuse.org/query/run?type=find&search_products[]=83"/> and <ulink
+    url="http://en.opensuse.org/openSUSE:Build_Service_Roadmap"/>.
   </para>
   <sect2 id="sec.concept.overview.features.developers">
    <title>Features for Developers</title>
diff --git a/documentation/books/en/xml/glossary.xml b/documentation/books/en/xml/glossary.xml
index 4fbf7e3..16cdfcd 100644
--- a/documentation/books/en/xml/glossary.xml
+++ b/documentation/books/en/xml/glossary.xml
@@ -177,7 +177,7 @@
     the openSUSE Build Service via command line. It serves as client for 
     the source code repository part of the build service, and it is used 
     to edit metadata or query about build results. 
-    Have a look at <ulink url="http://en.opensuse.org/Build_Service/CLI"/> 
+    Have a look at <ulink url="http://en.opensuse.org/openSUSE:OSC"/> 
     for further details.
    </para>
   </glossdef>
diff --git a/documentation/books/en/xml/kiwi_introduction.xml b/documentation/books/en/xml/kiwi_introduction.xml
index c55c43d..92bed9c 100644
--- a/documentation/books/en/xml/kiwi_introduction.xml
+++ b/documentation/books/en/xml/kiwi_introduction.xml
@@ -49,7 +49,7 @@
    software packages, organized in a package tree (also called an image description tree), and meta
    data. Because software repositories exist in many different formats, KIWI uses a package manager
    to access them. KIWI lets you use either the <ulink url="http://labix.org/smart">Smart Package
-    Manager</ulink> or <ulink url="http://en.opensuse.org/Zypper">Zypper</ulink>.</para>
+    Manager</ulink> or <ulink url="http://en.opensuse.org/Portal:Zypper">Zypper</ulink>.</para>
   <para>To prepare the physical extend, use the following command: </para>
   <para>
    <command>kiwi -p <replaceable>/path</replaceable></command>
diff --git a/documentation/books/en/xml/project_dependencies.xml b/documentation/books/en/xml/project_dependencies.xml
index 4f044ca..d196de7 100644
--- a/documentation/books/en/xml/project_dependencies.xml
+++ b/documentation/books/en/xml/project_dependencies.xml
@@ -23,7 +23,7 @@
    In the simple case, a project depends on just one repository.  But it is
    also possible to to make a project depend on a cascade of repositories.  For
    reference, see the Michael Schroeder's talks listed in <ulink
-   url="http://en.opensuse.org/Build_Service"/>.
+   url="http://en.opensuse.org/openSUSE:Build_Service_Presentations"/>.
   </para>
  </abstract>
 
diff --git a/documentation/books/en/xml/webclient_example.xml b/documentation/books/en/xml/webclient_example.xml
index 833158c..258948a 100644
--- a/documentation/books/en/xml/webclient_example.xml
+++ b/documentation/books/en/xml/webclient_example.xml
@@ -26,7 +26,7 @@
     <para>You have a buildservice account. This is the same as your Wiki or Bugzilla account. If you
      do not have one, you can register by clicking <guimenu>Login</guimenu> from the main page of
      the <ulink url="http://build.opensuse.org" /> page and create one.</para>
-    <remark>http://en.opensuse.org/Build_Service_Tutorial#Requirements</remark>
+    <remark>http://en.opensuse.org/openSUSE:Build_Service_Tutorial#Requirements</remark>
     <remark>TODO: Any recommendations for a login name?</remark>
    </listitem>
    <listitem>
@@ -73,7 +73,7 @@
 
  <sect2 id="sec.webclient.project.login">
   <title>Login</title>
-  <remark>INFO: From http://en.opensuse.org/Build_Service_Tutorial#Step_One_-_Login</remark>
+  <remark>INFO: From http://en.opensuse.org/openSUSE:Build_Service_Tutorial#Step_One_-_Login_and_one_time_Local_Project_setup</remark>
   <para>To login into the &bs; proceed as follows:</para>
 
   <procedure>
@@ -168,7 +168,7 @@
   <variablelist>
    <varlistentry>
     <term>
-     <ulink url="http://lists.opensuse.org/archive/opensuse-buildservice/">opensuse-buildservice
+     <ulink url="http://lists.opensuse.org/opensuse-buildservice/">opensuse-buildservice
       Mailinglist</ulink>
     </term>
     <listitem>
@@ -178,15 +178,15 @@
    </varlistentry>
    <varlistentry>
     <term>
-     <ulink url="http://en.opensuse.org/SUSE_Build_Tutorial">SUSE Build Tutorial</ulink>
+     <ulink url="http://en.opensuse.org/Portal:Packaging">openSUSE Packaging Portal</ulink>
     </term>
     <listitem>
-     <para>Explains how to build packages that conforms the SUSE policy.</para>
+     <para>Explains how to build packages that conforms the openSUSE policy.</para>
     </listitem>
    </varlistentry>
    <varlistentry>
     <term>
-     <ulink url="http://en.opensuse.org/Build_Service/Tips_and_Tricks">Tips and Tricks</ulink>
+     <ulink url="http://en.opensuse.org/openSUSE:Build_Service_Tips_and_Tricks">Tips and Tricks</ulink>
     </term>
     <listitem>
      <para>Some collections with tips and tricks to work with the &bs;.</para>
diff --git a/src/api/lib/wizard.rb b/src/api/lib/wizard.rb
index 3e2070d..aaa3e59 100644
--- a/src/api/lib/wizard.rb
+++ b/src/api/lib/wizard.rb
@@ -136,7 +136,7 @@ class Wizard
     "group"       => {
       'type'    => "text",
       'label'   => "Package group",
-      'legend'  => "See http://en.opensuse.org/SUSE_Package_Conventions/RPM_Groups",
+      'legend'  => "See http://en.opensuse.org/openSUSE:Package_group_guidelines",
     },
   }
 
diff --git a/src/backend/testdata/productdefinition/openSUSE/openSUSE11.0.product b/src/backend/testdata/productdefinition/openSUSE/openSUSE11.0.product
index e19ce50..2afeba2 100644
--- a/src/backend/testdata/productdefinition/openSUSE/openSUSE11.0.product
+++ b/src/backend/testdata/productdefinition/openSUSE/openSUSE11.0.product
@@ -18,7 +18,7 @@
         <version>11</version>
         <release>0</release> <!-- needed for example if an ISO has to rebuild /* NEEDS TO BE DISCUSSED */ -->
 
-        <!-- Please have a look at the Products file definition (http://en.opensuse.org/Build_Service/Product_Definition/products_file).
+        <!-- Please have a look at the Products file definition (http://en.opensuse.org/openSUSE:Build_Service_Concept_Product_Definition).
              for details about the ncc_target. -->
         <register>
             <target>openSUSE-11.1-%%{_target_cpu}</target>
diff --git a/src/backend/testdata/productdefinition/products/product.sle11-sles.xml b/src/backend/testdata/productdefinition/products/product.sle11-sles.xml
index afdb151..cab76ed 100644
--- a/src/backend/testdata/productdefinition/products/product.sle11-sles.xml
+++ b/src/backend/testdata/productdefinition/products/product.sle11-sles.xml
@@ -26,7 +26,7 @@
       <version>11</version>
       <release>0</release>
       <!-- ^^^ needed for example if an ISO has to rebuild /* NEEDS TO BE DISCUSSED */ -->
-      <!-- Please have a look at the Products file definition (http://en.opensuse.org/Build_Service/Product_Definition/products_file).
+      <!-- Please have a look at the Products file definition (http://en.opensuse.org/openSUSE:Build_Service_Concept_Product_Definition).
       for details about the ncc_target. -->
       <!--
       /* required for NCC registration */ 
diff --git a/src/webui/README.install b/src/webui/README.install
index e85530e..64c075a 100644
--- a/src/webui/README.install
+++ b/src/webui/README.install
@@ -2,7 +2,7 @@
 
 The webclient can be run and developed locally without having to setup a complete 
 buildservice. A tutorial for setting up your local development instance and how to contribute 
-can be found in the wiki: http://en.opensuse.org/Build_Service/Build_Service_Installation_Tutorial/Easy_OBS_Web_Client_Development
+can be found in the wiki: http://en.opensuse.org/openSUSE:Build_Service_Webclient_Development 
 
 
 = Required packages can be installed from the devel:/languages:/ruby:/extensions repo: 
diff --git a/src/webui/app/views/driver_update/create.html.erb b/src/webui/app/views/driver_update/create.html.erb
index 43f4d79..6047e4a 100644
--- a/src/webui/app/views/driver_update/create.html.erb
+++ b/src/webui/app/views/driver_update/create.html.erb
@@ -84,7 +84,7 @@
 
 <h2>Driver update disk wizard</h2>
 
-<p>This editor helps to create the configuration for a <a href="http://en.opensuse.org/Libzypp/Products/DuD/Installation">driver update disk</a>.
+<p>This editor helps to create the configuration for a <a href="http://en.opensuse.org/Portal:Libzypp#FIXME">driver update disk</a>.
   It will store it's settings in the _service file which generates the full kiwi config on the build server or
   your workstation when using osc.</p>
 
diff --git a/src/webui/app/views/main/about.rhtml b/src/webui/app/views/main/about.rhtml
index fbce466..25f220f 100644
--- a/src/webui/app/views/main/about.rhtml
+++ b/src/webui/app/views/main/about.rhtml
@@ -3,6 +3,6 @@
 <h2>About</h2>
 
 <p>This is the web client for the openSUSE build service.</p>
-<p>Check the openSUSE <a href="http://en.opensuse.org/Build_Service">
+<p>Check the openSUSE <a href="http://en.opensuse.org/Portal:Build_Service">
    openSUSE Build Service wiki page</a> for details.</p>
 
diff --git a/src/webui/app/views/main/index.rhtml b/src/webui/app/views/main/index.rhtml
index 926cd74..a9b8a4d 100644
--- a/src/webui/app/views/main/index.rhtml
+++ b/src/webui/app/views/main/index.rhtml
@@ -9,13 +9,13 @@
 
   <p class="description">
     The
-    <%= link_to 'openSUSE Build Service (OBS)', 'http://wiki.opensuse.org/openSUSE:Build_Service', :title => 'more Information about the Build Service in the openSUSE wiki ...' -%>
+    <%= link_to 'openSUSE Build Service (OBS)', 'http://en.opensuse.org/Portal:Build_Service', :title => 'more Information about the Build Service in the openSUSE wiki ...' -%>
     is an open and complete distribution development platform that provides a transparent infrastructure for development of the openSUSE distribution.
   </p>
   <p class="description">
     The openSUSE Build Service provides software developers with a convenient and easy to use tool to create and release open source software 
-    for <%= link_to 'openSUSE and other Linux distributions', 'http://en.opensuse.org/Build_Service/cross_distribution_package_how_to', :title => 'Cross Distribution Package How To' -%>
-    like Ubuntu, Fedora, Mandriva and Debian on different hardware architectures and for a broad user audience. In addition to that you can also build appliances via <%= link_to 'kiwi', 'http://wiki.opensuse.org/openSUSE:Build_Service_KIWI' -%> inside of the OBS based on the packages you build before.
+    for <%= link_to 'openSUSE and other Linux distributions', 'http://en.opensuse.org/openSUSE:Build_Service_cross_distribution_howto', :title => 'Cross Distribution Package How To' -%>
+    like Ubuntu, Fedora, Mandriva and Debian on different hardware architectures and for a broad user audience. In addition to that you can also build appliances via <%= link_to 'kiwi', 'http://en.opensuse.org/openSUSE:Build_Service_KIWI' -%> inside of the OBS based on the packages you build before.
   </p>
   <p class="description">
     With the openSUSE Build Service, users can easily <%= link_to 'find the latest open source packages', 'http://software.opensuse.org/search', :title => 'Software Search' -%> they are looking for and customize them.
@@ -24,7 +24,7 @@
 
 
   <p class="description">
-    The openSUSE Build Service developer team is greeting you. In case you use your OBS productive in your facility, please do us a favor and add yourself at <%= link_to 'this wiki page', 'http://wiki.opensuse.org/openSUSE:Build_Service_installations' -%>. Have fun and fast build times!
+    The openSUSE Build Service developer team is greeting you. In case you use your OBS productive in your facility, please do us a favor and add yourself at <%= link_to 'this wiki page', 'http://en.opensuse.org/openSUSE:Build_Service_installations' -%>. Have fun and fast build times!
   </p>
 
   <p class="description">
diff --git a/src/webui/app/views/package/show.html.erb b/src/webui/app/views/package/show.html.erb
index fb9b494..83dda2f 100644
--- a/src/webui/app/views/package/show.html.erb
+++ b/src/webui/app/views/package/show.html.erb
@@ -85,7 +85,7 @@
 
       <% if @package.name =~ %r{^_patchinfo} %>
         <p>
-          <%= image_tag 'icons/information.png' %> This package creates a patchinfo used for <%= link_to 'maintenance updates', 'http://wiki.opensuse.org/openSUSE:Maintenance' %>.
+          <%= image_tag 'icons/information.png' %> This package creates a patchinfo used for <%= link_to 'maintenance updates', 'http://en.opensuse.org/Portal:Maintenance' %>.
           Please use the <%= link_to 'wizard', :controller => :patchinfo, :action => :show, :package => @package, :project => @project %> to edit it.
         </p>
       <% end %>
diff --git a/src/webui/app/views/user/request_ichain.rhtml b/src/webui/app/views/user/request_ichain.rhtml
index 3d0cd2d..b2c46a1 100644
--- a/src/webui/app/views/user/request_ichain.rhtml
+++ b/src/webui/app/views/user/request_ichain.rhtml
@@ -15,7 +15,7 @@
 
   <p>
   Also make sure you have read
-  <a href="http://en.opensuse.org/Application_Black_List">http://en.opensuse.org/Application_Black_List</a>
+  <a href="http://en.opensuse.org/openSUSE:Build_Service_Application_Blacklist">http://en.opensuse.org/openSUSE:Build_Service_Application_Blacklist</a>
   and understood why you can't build some packages in the openSUSE Build Service.</p>
   
   <p>
diff --git a/src/webui/app/views/vendor/bento/layouts/_header.html.erb b/src/webui/app/views/vendor/bento/layouts/_header.html.erb
index 1f1c343..c04c65b 100644
--- a/src/webui/app/views/vendor/bento/layouts/_header.html.erb
+++ b/src/webui/app/views/vendor/bento/layouts/_header.html.erb
@@ -11,10 +11,10 @@
 
       <ul id="global-navigation">
         <!-- change link to en.o.o after transition -->
-        <li id="item-downloads"><a href="http://wiki.opensuse.org//openSUSE:Browse#Downloads">Downloads</a></li>
-        <li id="item-support"><a href="http://wiki.opensuse.org//openSUSE:Browse#Support">Support</a></li>
-        <li id="item-community"><a href="http://wiki.opensuse.org//openSUSE:Browse#Community">Community</a></li>
-        <li id="item-development"><a href="http://wiki.opensuse.org//openSUSE:Browse#Development">Development</a></li>
+        <li id="item-downloads"><a href="http://en.opensuse.org//openSUSE:Browse#Downloads">Downloads</a></li>
+        <li id="item-support"><a href="http://en.opensuse.org//openSUSE:Browse#Support">Support</a></li>
+        <li id="item-community"><a href="http://en.opensuse.org//openSUSE:Browse#Community">Community</a></li>
+        <li id="item-development"><a href="http://en.opensuse.org//openSUSE:Browse#Development">Development</a></li>
           <% if user -%>
             <li id="item-favorites" style="float: right;"><a href="<%= url_for :controller => "home", :action => :list_my %>">Watchlist</a></li>
           <% end -%>
diff --git a/src/webui/app/views/vendor/bento/layouts/application.html.erb b/src/webui/app/views/vendor/bento/layouts/application.html.erb
index a694f1c..be0d693 100644
--- a/src/webui/app/views/vendor/bento/layouts/application.html.erb
+++ b/src/webui/app/views/vendor/bento/layouts/application.html.erb
@@ -102,11 +102,11 @@
         <strong class="grey-medium spacer1">Help</strong>
         <ul>
           <% @helplinks = [
-            { 'Build Service Portal'  => 'http://wiki.opensuse.org/Portal:Build_Service' },
-            { 'Building Packages'  => 'http://en.opensuse.org/SUSE_Build_Tutorial' },
-            { 'Writing spec Files' => 'http://en.opensuse.org/Packaging/SUSE_Package_Conventions' },
-            { 'Reporting a Bug'   => 'http://en.opensuse.org/Submit_a_Bug' },
-            { 'Forums'             => 'http://forums.opensuse.org/development/opensuse-build-service-obs/' } ]
+            { 'Build Service Portal'  => 'http://en.opensuse.org/Portal:Build_Service' },
+            { 'Building Packages'  => 'http://en.opensuse.org/Portal:Packaging' },
+            { 'Writing spec Files' => 'http://en.opensuse.org/openSUSE:Specfile_guidelines' },
+            { 'Reporting a Bug'   => 'http://en.opensuse.org/openSUSE:Submitting_bug_reports' },
+            { 'Forums'             => 'http://forums.opensuse.org/english/development/opensuse-build-service-obs/' } ]
 
           @helplinks.each do |helplink|
             for k in helplink.keys %>
-- 
1.7.1