--- vmmon-only/common/task.c
+++ vmmon-only/common/task.c
@@ -26,6 +26,7 @@
  * is common file, yes?  And Windows do not have page.h, do they?
  */
 #define _I386_PAGE_H
+#define _ASM_X86_PAGE_H
 /* On Linux, must come before any inclusion of asm/page.h --hpreg */
 #include "hostKernel.h"
 #ifdef linux
--- vmmon-only/include/vcpuset.h
+++ vmmon-only/include/vcpuset.h
@@ -71,7 +71,7 @@
 #define ffs(x) ffs_x86_64(x)
 
 #elif defined MODULE
-   #include "asm/bitops.h"
+   #include "linux/bitops.h"
 #elif defined __APPLE__ && defined KERNEL
    /* 
     * XXXMACOS An ugly hack to resolve redefinition of PAGE_ defines 
--- vmnet-only/compat_sock.h
+++ vmnet-only/compat_sock.h
@@ -8,6 +8,14 @@
 
 #include <net/sock.h>
 
+/* http://forum.openvz.org/index.php?t=msg&goto=23299& */
+static inline void sock_valbool_flag(struct sock *sk, int bit, int valbool)
+{
+    if (valbool)
+	sock_set_flag(sk, bit);
+    else
+	sock_reset_flag(sk, bit);
+}
 
 /*
  * Between 2.5.70 and 2.5.71 all sock members were renamed from XXX to sk_XXX.
--- vmnet-only/filter.c
+++ vmnet-only/filter.c
@@ -12,6 +12,10 @@
 #include <linux/ip.h>
 #include "compat_skbuff.h"
 #include <linux/netdevice.h>
+#define NF_IP_LOCAL_OUT NF_INET_LOCAL_OUT
+#define NF_IP_LOCAL_IN NF_INET_LOCAL_IN
+#define NF_IP_POST_ROUTING NF_INET_POST_ROUTING
+
 /*
  * All this makes sense only if NETFILTER support is configured in our kernel.
  */
--- Kbuild	2008/05/05 22:43:55	1.1
+++ Kbuild	2008/05/05 23:02:49
@@ -1,11 +1,12 @@
 obj-m += vmmon.o
 
-vmmon-objs      := vmmon-only/linux/driver.o vmmon-only/linux/hostif.o vmmon-only/common/cpuid.o vmmon-only/common/hash.o vmmon-only/common/memtrack.o vmmon-only/common/phystrack.o vmmon-only/common/task.o vmmon-only/common/vmx86.o vmmon-only/vmcore/compat.o vmmon-only/vmcore/moduleloop.o
+vmmon-objs      := vmmon-only/linux/driver.o vmmon-only/linux/hostif.o vmmon-only/linux/driverLog.o vmmon-only/common/cpuid.o vmmon-only/common/hash.o vmmon-only/common/memtrack.o vmmon-only/common/phystrack.o vmmon-only/common/task.o vmmon-only/common/vmx86.o vmmon-only/vmcore/compat.o vmmon-only/vmcore/moduleloop.o vmmon-only/common/vmciDriver.o vmmon-only/common/vmciContext.o vmmon-only/common/vmciDatagram.o vmmon-only/common/vmciDs.o vmmon-only/common/vmciGroup.o vmmon-only/common/vmciHashtable.o vmmon-only/common/vmciProcess.o vmmon-only/common/vmciResource.o vmmon-only/common/vmciSharedMem.o
 
 EXTRA_CFLAGS += -Wall -Wstrict-prototypes -DVME_DEFAULT=VME_S1B1 -DVMW_USING_KBUILD 
 VMMON_FLAGS := -DVMMON -DVMCORE -I$(src)/vmmon-only/include -I$(src)/vmmon-only/common -I$(src)/vmmon-only/linux -I$(src)/vmmon-only/vmcore -DVMW_NOPAGE_261 -DVMWARE__FIX_IO_APIC_BASE=FIX_IO_APIC_BASE_0 -DVMW_HAVE_EPOLL -DVMW_HAVE_SET_USER_NICE
 CFLAGS_driver.o := $(VMMON_FLAGS)
 CFLAGS_hostif.o := $(VMMON_FLAGS)
+CFLAGS_driverLog.o := $(VMMON_FLAGS)
 CFLAGS_cpuid.o := $(VMMON_FLAGS)
 CFLAGS_hash.o := $(VMMON_FLAGS)
 CFLAGS_memtrack.o := $(VMMON_FLAGS)
@@ -13,6 +14,15 @@
 CFLAGS_vmx86.o := $(VMMON_FLAGS)
 CFLAGS_compat.o := $(VMMON_FLAGS)
 CFLAGS_moduleloop.o := $(VMMON_FLAGS)
+CFLAGS_vmciDriver.o := $(VMMON_FLAGS)
+CFLAGS_vmciContext.o := $(VMMON_FLAGS)
+CFLAGS_vmciDatagram.o := $(VMMON_FLAGS)
+CFLAGS_vmciDs.o := $(VMMON_FLAGS)
+CFLAGS_vmciGroup.o := $(VMMON_FLAGS)
+CFLAGS_vmciHashtable.o := $(VMMON_FLAGS)
+CFLAGS_vmciProcess.o := $(VMMON_FLAGS)
+CFLAGS_vmciResource.o := $(VMMON_FLAGS)
+CFLAGS_vmciSharedMem.o := $(VMMON_FLAGS)
 CFLAGS_task.o += $(VMMON_FLAGS) -x c++ -fno-exceptions
 
 obj-m   += vmnet.o
@@ -23,7 +33,7 @@
 SMAC := smac_linux.x386.o
 endif
 
-vmnet-objs      := vmnet-only/vmnet_driver.o vmnet-only/hub.o vmnet-only/userif.o vmnet-only/netif.o vmnet-only/bridge.o vmnet-only/procfs.o vmnet-only/smac_compat.o vmnet-only/$(SMAC)
+vmnet-objs      := vmnet-only/vmnet_driver.o vmnet-only/hub.o vmnet-only/userif.o vmnet-only/netif.o vmnet-only/bridge.o vmnet-only/filter.o vmnet-only/procfs.o vmnet-only/smac_compat.o vmnet-only/$(SMAC)
 
 VMNET_FLAGS := -I$(src)/vmnet-only -DVMW_HAVE_EPOLL -DVMW_HAVE_SK_WMEM_ALLOC -DVMW_HAVE_SK_ALLOC_WITH_PROTO -DVMW_HAVE_SET_USER_NICE
 CFLAGS_vmnet_driver.o := $(VMNET_FLAGS)
@@ -31,6 +41,7 @@
 CFLAGS_userif.o := $(VMNET_FLAGS)
 CFLAGS_netif.o := $(VMNET_FLAGS)
 CFLAGS_bridge.o := $(VMNET_FLAGS)
+CFLAGS_filter.o := $(VMNET_FLAGS)
 CFLAGS_procfs.o := $(VMNET_FLAGS)
 CFLAGS_smac_compat.o := $(VMNET_FLAGS)
 CFLAGS_$(SMAC) := $(VMNET_FLAGS)