diff -Naur gnome-settings-daemon-2.23.4_old/configure.ac gnome-settings-daemon-2.23.4/configure.ac
--- gnome-settings-daemon-2.23.4_old/configure.ac	2008-06-17 15:20:33.000000000 +0400
+++ gnome-settings-daemon-2.23.4/configure.ac	2008-07-25 18:18:59.000000000 +0400
@@ -413,6 +413,7 @@
 gnome-settings-daemon/Makefile
 plugins/Makefile
 plugins/a11y-keyboard/Makefile
+plugins/apport/Makefile
 plugins/background/Makefile
 plugins/clipboard/Makefile
 plugins/common/Makefile
diff -Naur gnome-settings-daemon-2.23.4_old/data/apps_apport.schemas.in gnome-settings-daemon-2.23.4/data/apps_apport.schemas.in
--- gnome-settings-daemon-2.23.4_old/data/apps_apport.schemas.in	1970-01-01 03:00:00.000000000 +0300
+++ gnome-settings-daemon-2.23.4/data/apps_apport.schemas.in	2008-07-25 22:39:54.000000000 +0400
@@ -0,0 +1,15 @@
+<gconfschemafile>
+  <schemalist>
+    <schema>
+      <key>/schemas/apps/apport/show_apport_crashes</key>
+      <applyto>/apps/apport/show_apport_crashes</applyto>
+      <type>bool</type>
+      <default>true</default>
+      <locale name="C">
+        <short>Display apport crash reports automatically</short>
+        <long>If this is disabled, the user will not be notified about pending apport crash reports.</long>
+      </locale>
+    </schema>
+
+  </schemalist>
+</gconfschemafile>
diff -Naur gnome-settings-daemon-2.23.4_old/data/Makefile.am gnome-settings-daemon-2.23.4/data/Makefile.am
--- gnome-settings-daemon-2.23.4_old/data/Makefile.am	2008-05-08 15:48:32.000000000 +0400
+++ gnome-settings-daemon-2.23.4/data/Makefile.am	2008-07-25 23:31:04.000000000 +0400
@@ -5,6 +5,7 @@
 schemasdir = $(GCONF_SCHEMA_FILE_DIR)
 schemas_in_files = 						\
 	gnome-settings-daemon.schemas.in			\
+	apps_apport.schemas.in                                  \
 	apps_gnome_settings_daemon_keybindings.schemas.in	\
 	apps_gnome_settings_daemon_screensaver.schemas.in	\
 	desktop_gnome_font_rendering.schemas.in			\
diff -Naur gnome-settings-daemon-2.23.4_old/plugins/apport/apport.gnome-settings-plugin.in gnome-settings-daemon-2.23.4/plugins/apport/apport.gnome-settings-plugin.in
--- gnome-settings-daemon-2.23.4_old/plugins/apport/apport.gnome-settings-plugin.in	1970-01-01 03:00:00.000000000 +0300
+++ gnome-settings-daemon-2.23.4/plugins/apport/apport.gnome-settings-plugin.in	2008-07-25 18:15:29.000000000 +0400
@@ -0,0 +1,8 @@
+[GNOME Settings Plugin]
+Module=apport
+IAge=0
+_Name=Apport
+_Description=Checks for new Apport crash reports and launches a handling application
+Authors=Nikolay Derkach
+Copyright=Copyright © 2008 Nikolay Derkach
+Website=
diff -Naur gnome-settings-daemon-2.23.4_old/plugins/apport/gsd-apport-manager.c gnome-settings-daemon-2.23.4/plugins/apport/gsd-apport-manager.c
--- gnome-settings-daemon-2.23.4_old/plugins/apport/gsd-apport-manager.c	1970-01-01 03:00:00.000000000 +0300
+++ gnome-settings-daemon-2.23.4/plugins/apport/gsd-apport-manager.c	2008-07-27 23:01:13.000000000 +0400
@@ -0,0 +1,241 @@
+/*
+ * Copyright (C) 2008 Nikolay Derkach <nderkach@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ */
+ 
+/* Some code was taken from update-notifier */ 
+
+#include <gio/gio.h>
+/* lcn */
+#include <gnome.h>
+
+#include "gnome-settings-profile.h"
+#include "gsd-apport-manager.h"
+
+
+static void     gsd_apport_manager_class_init  (GsdApportManagerClass *klass);
+static void     gsd_apport_manager_init        (GsdApportManager      *apport_manager);
+
+G_DEFINE_TYPE (GsdApportManager, gsd_apport_manager, G_TYPE_OBJECT)
+
+static gpointer manager_object = NULL;
+
+
+static gboolean
+check_system_crashes ()
+{
+        int exitcode;
+
+        // check for system crashes
+        if(!g_spawn_command_line_sync(CRASHREPORT_HELPER " --system", NULL, NULL, 
+				 &exitcode, NULL)) {
+                g_warning("Can not run %s\n", CRASHREPORT_HELPER);
+                return FALSE;
+        }
+
+        return exitcode == 0;
+}
+
+void
+invoke_with_gnomesu (gchar *cmd)
+{
+    	gchar *argv[3];
+    	argv[0] = "/usr/bin/gnomesu";
+    	argv[1] = cmd;
+    	argv[2] = NULL;
+
+    	g_spawn_async (NULL, argv, NULL, 0, NULL, NULL, NULL, NULL);
+}
+
+static gboolean 
+run_apport (TrayApplet *ta)
+{
+        g_debug("fire up the crashreport tool\n");
+        if (check_system_crashes())
+        {
+                invoke_with_gnomesu(CRASHREPORT_REPORT_APP);
+                return TRUE;
+        } else
+        return g_spawn_command_line_async(CRASHREPORT_REPORT_APP, NULL);
+}
+
+static void 
+hide_crash_applet (TrayApplet *ta)
+{
+        gtk_status_icon_set_visible(ta->tray_icon, FALSE);
+}
+
+gboolean
+crashreport_check (TrayApplet *ta)
+{
+        int crashreports_found = 0;
+        static gboolean first_run = TRUE;
+        gboolean system_crashes;
+
+        g_debug("crashreport_check\n");
+
+        // don't do anything if no apport-gtk is installed
+        if(!g_file_test(CRASHREPORT_REPORT_APP, G_FILE_TEST_IS_EXECUTABLE))
+                return FALSE;
+
+        // Check whether the user doesn't want notifications
+        ta->user_data = gconf_client_get_default ();
+        if (!gconf_client_get_bool ((GConfClient*) ta->user_data,
+                GCONF_KEY_APPORT_NOTIFICATIONS, NULL)) {
+                g_debug("apport notifications disabled in gconf, not displaying crashes");
+                return FALSE;
+        }
+        g_object_unref (ta->user_data);
+
+        // check for (new) reports by calling CRASHREPORT_HELPER
+        // and checking the return code
+        int exitcode;
+        if(!g_spawn_command_line_sync(CRASHREPORT_HELPER, NULL, NULL, 
+				 &exitcode, NULL)) {
+                g_warning("Can not run %s\n", CRASHREPORT_HELPER);
+                return FALSE;
+        }
+        // exitcode == 0: repots found, else no reports
+        system_crashes = check_system_crashes();
+        crashreports_found = !exitcode || system_crashes;
+
+        gboolean visible = gtk_status_icon_get_visible(ta->tray_icon);
+
+        if((crashreports_found > 0) && (system_crashes || first_run)) {
+                gtk_status_icon_set_tooltip(ta->tray_icon,
+				  _("Crash report detected"));
+                gtk_status_icon_set_visible(ta->tray_icon, TRUE);
+        }
+        // crashreport found and already visible
+        else if((crashreports_found > 0) && !(system_crashes || first_run)) {
+                run_apport(ta);
+                // if apport was run, we don't care anymore and hide the icon
+                crashreports_found = 0;
+        }
+
+        // no crashreports, but visible
+        if((crashreports_found == 0) && visible) {
+                hide_crash_applet(ta);
+        }
+
+        first_run = FALSE;
+        return TRUE;
+}
+
+static void
+apport_watchdir_changed (GFileMonitor       *monitor,
+                         GFile              *file,
+                         GFile              *other_file,
+                         GFileMonitorEvent   event_type,
+                         gpointer            user_data)
+{
+        TrayApplet *ta = (TrayApplet *)user_data;
+        if(event_type == G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED) // it'd better be something like inotify's CLOSE_WRITE
+        {
+                g_debug("G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED");
+                crashreport_check(ta);                
+        }
+}    
+
+static gboolean
+button_release_cb (GtkWidget *widget,
+		           TrayApplet *ta)
+{
+        run_apport(ta);
+        hide_crash_applet(ta);
+        
+	    return TRUE;
+}
+
+gboolean
+trayapplet_create (TrayApplet *ta, char *name)
+{
+    	/* setup widgets */
+    	ta->tray_icon = gtk_status_icon_new_from_icon_name (name);
+    	ta->name = name;
+    	gtk_status_icon_set_visible (ta->tray_icon, FALSE);
+    
+    	return TRUE;
+}
+
+void
+tray_icon_init (TrayApplet *ta)
+{
+        g_signal_connect(G_OBJECT(ta->tray_icon),
+		         "activate",
+			 G_CALLBACK (button_release_cb),
+			 ta);
+
+    	/* Check for crashes for the first time */
+	    crashreport_check (ta);
+}
+
+gboolean
+gsd_apport_manager_start (GsdApportManager *manager,
+                          GError          **error)
+{
+        g_debug ("Starting apport manager");
+        gnome_settings_profile_start (NULL);
+        
+        /* crashreport detected icon */
+        ta = g_new0 (TrayApplet, 1);
+        trayapplet_create(ta, "apport");
+        tray_icon_init(ta);
+
+        GFile *file = g_file_new_for_path(CRASHREPORT_DIR);
+        GFileMonitor *m = g_file_monitor_directory(file, 0, NULL, NULL);
+        g_signal_connect(m, "changed", G_CALLBACK(apport_watchdir_changed), ta); 
+        
+        gnome_settings_profile_end (NULL);
+
+        return TRUE;
+}
+
+
+void
+gsd_apport_manager_stop (GsdApportManager *manager)
+{
+        g_debug ("Stopping apport manager");
+}
+
+static void
+gsd_apport_manager_class_init (GsdApportManagerClass *klass)
+{
+        /* blank */
+}
+
+
+static void
+gsd_apport_manager_init (GsdApportManager *manager)
+{
+        /* blank */
+}
+
+
+GsdApportManager *
+gsd_apport_manager_new (void)
+{
+        if (manager_object != NULL) {
+                g_object_ref (manager_object);
+        } else {
+                manager_object = g_object_new (GSD_TYPE_APPORT_MANAGER, NULL);
+                g_object_add_weak_pointer (manager_object,
+                                           (gpointer *) &manager_object);
+        }
+
+        return GSD_APPORT_MANAGER (manager_object);
+}
diff -Naur gnome-settings-daemon-2.23.4_old/plugins/apport/gsd-apport-manager.h gnome-settings-daemon-2.23.4/plugins/apport/gsd-apport-manager.h
--- gnome-settings-daemon-2.23.4_old/plugins/apport/gsd-apport-manager.h	1970-01-01 03:00:00.000000000 +0300
+++ gnome-settings-daemon-2.23.4/plugins/apport/gsd-apport-manager.h	2008-07-27 23:01:14.000000000 +0400
@@ -0,0 +1,71 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2008 Nikolay Derkach <nderkach@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ */
+
+#ifndef __GSD_APPORT_MANAGER_H
+#define __GSD_APPORT_MANAGER_H
+
+#include <glib-object.h>
+#include <gtk/gtk.h>
+#include <gconf/gconf-client.h>
+
+G_BEGIN_DECLS
+
+#define GSD_TYPE_APPORT_MANAGER         (gsd_apport_manager_get_type ())
+#define GSD_APPORT_MANAGER(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), GSD_TYPE_APPORT_MANAGER, GsdApportManager))
+#define GSD_APPORT_MANAGER_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), GSD_TYPE_APPORT_MANAGER, GsdApportManagerClass))
+#define GSD_IS_APPORT_MANAGER(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), GSD_TYPE_APPORT_MANAGER))
+#define GSD_IS_APPORT_MANAGER_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), GSD_TYPE_APPORT_MANAGER))
+#define GSD_APPORT_MANAGER_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GSD_TYPE_APPORT_MANAGER, GsdApportManagerClass))
+
+#define CRASHREPORT_HELPER "/usr/share/apport/apport-checkreports"
+#define CRASHREPORT_REPORT_APP "/usr/share/apport/apport-gtk"
+#define CRASHREPORT_DIR "/var/crash/"
+
+#define GCONF_KEY_APPORT_NOTIFICATIONS "/apps/apport/show_apport_crashes"
+
+typedef struct {
+        GObject                        parent;
+} GsdApportManager;
+
+typedef struct {
+        GObjectClass   parent_class;
+} GsdApportManagerClass;
+
+GType                    gsd_apport_manager_get_type      (void);
+
+GsdApportManager * gsd_apport_manager_new           (void);
+gboolean                 gsd_apport_manager_start         (GsdApportManager  *manager,
+                                                                 GError                 **error);
+void                     gsd_apport_manager_stop          (GsdApportManager  *manager);
+
+typedef struct _TrayApplet TrayApplet;
+struct _TrayApplet 
+{
+   GtkStatusIcon *tray_icon;
+   GtkWidget *menu;
+   char *name;
+   GConfClient *user_data;
+};
+
+TrayApplet *ta;
+
+G_END_DECLS
+
+#endif /* __GSD_APPORT_MANAGER_H */
diff -Naur gnome-settings-daemon-2.23.4_old/plugins/apport/gsd-apport-plugin.c gnome-settings-daemon-2.23.4/plugins/apport/gsd-apport-plugin.c
--- gnome-settings-daemon-2.23.4_old/plugins/apport/gsd-apport-plugin.c	1970-01-01 03:00:00.000000000 +0300
+++ gnome-settings-daemon-2.23.4/plugins/apport/gsd-apport-plugin.c	2008-07-25 18:15:29.000000000 +0400
@@ -0,0 +1,104 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2008 Nikolay Derkach <nderkach@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2, or (at your option)
+ * any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ */
+
+#include "config.h"
+
+#include <glib/gi18n-lib.h>
+#include <gmodule.h>
+
+#include "gnome-settings-plugin.h"
+#include "gsd-apport-plugin.h"
+#include "gsd-apport-manager.h"
+
+struct GsdApportPluginPrivate {
+        GsdApportManager *manager;
+};
+
+#define GSD_APPORT_PLUGIN_GET_PRIVATE(object) (G_TYPE_INSTANCE_GET_PRIVATE ((object), GSD_TYPE_APPORT_PLUGIN, GsdApportPluginPrivate))
+
+GNOME_SETTINGS_PLUGIN_REGISTER (GsdApportPlugin, gsd_apport_plugin)
+
+static void
+gsd_apport_plugin_init (GsdApportPlugin *plugin)
+{
+        plugin->priv = GSD_APPORT_PLUGIN_GET_PRIVATE (plugin);
+
+        g_debug ("GsdApportPlugin initializing");
+
+        plugin->priv->manager = gsd_apport_manager_new ();
+}
+
+static void
+gsd_apport_plugin_finalize (GObject *object)
+{
+        GsdApportPlugin *plugin;
+
+        g_return_if_fail (object != NULL);
+        g_return_if_fail (GSD_IS_APPORT_PLUGIN (object));
+
+        g_debug ("GsdApportPlugin finalizing");
+
+        plugin = GSD_APPORT_PLUGIN (object);
+
+        g_return_if_fail (plugin->priv != NULL);
+
+        if (plugin->priv->manager != NULL) {
+                g_object_unref (plugin->priv->manager);
+        }
+
+        G_OBJECT_CLASS (gsd_apport_plugin_parent_class)->finalize (object);
+}
+
+static void
+impl_activate (GnomeSettingsPlugin *plugin)
+{
+        gboolean res;
+        GError  *error;
+
+        g_debug ("Activating apport plugin");
+
+        error = NULL;
+        res = gsd_apport_manager_start (GSD_APPORT_PLUGIN (plugin)->priv->manager, &error);
+        if (! res) {
+                g_warning ("Unable to start apport manager: %s", error->message);
+                g_error_free (error);
+        }
+}
+
+static void
+impl_deactivate (GnomeSettingsPlugin *plugin)
+{
+        g_debug ("Deactivating apport plugin");
+        gsd_apport_manager_stop (GSD_APPORT_PLUGIN (plugin)->priv->manager);
+}
+
+static void
+gsd_apport_plugin_class_init (GsdApportPluginClass *klass)
+{
+        GObjectClass             *object_class = G_OBJECT_CLASS (klass);
+        GnomeSettingsPluginClass *plugin_class = GNOME_SETTINGS_PLUGIN_CLASS (klass);
+
+        object_class->finalize = gsd_apport_plugin_finalize;
+
+        plugin_class->activate = impl_activate;
+        plugin_class->deactivate = impl_deactivate;
+
+        g_type_class_add_private (klass, sizeof (GsdApportPluginPrivate));
+}
diff -Naur gnome-settings-daemon-2.23.4_old/plugins/apport/gsd-apport-plugin.h gnome-settings-daemon-2.23.4/plugins/apport/gsd-apport-plugin.h
--- gnome-settings-daemon-2.23.4_old/plugins/apport/gsd-apport-plugin.h	1970-01-01 03:00:00.000000000 +0300
+++ gnome-settings-daemon-2.23.4/plugins/apport/gsd-apport-plugin.h	2008-07-25 18:15:29.000000000 +0400
@@ -0,0 +1,57 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2008 Nikolay Derkach <nderkach@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2, or (at your option)
+ * any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ */
+
+#ifndef __GSD_APPORT_PLUGIN_H__
+#define __GSD_APPORT_PLUGIN_H__
+
+#include <glib.h>
+#include <glib-object.h>
+#include <gmodule.h>
+
+#include "gnome-settings-plugin.h"
+
+G_BEGIN_DECLS
+
+#define GSD_TYPE_APPORT_PLUGIN                (gsd_apport_plugin_get_type ())
+#define GSD_APPORT_PLUGIN(o)                  (G_TYPE_CHECK_INSTANCE_CAST ((o), GSD_TYPE_APPORT_PLUGIN, GsdApportPlugin))
+#define GSD_APPORT_PLUGIN_CLASS(k)            (G_TYPE_CHECK_CLASS_CAST((k), GSD_TYPE_APPORT_PLUGIN, GsdApportPluginClass))
+#define GSD_IS_APPORT_PLUGIN(o)               (G_TYPE_CHECK_INSTANCE_TYPE ((o), GSD_TYPE_APPORT_PLUGIN))
+#define GSD_IS_APPORT_PLUGIN_CLASS(k)         (G_TYPE_CHECK_CLASS_TYPE ((k), GSD_TYPE_APPORT_PLUGIN))
+#define GSD_APPORT_PLUGIN_GET_CLASS(o)        (G_TYPE_INSTANCE_GET_CLASS ((o), GSD_TYPE_APPORT_PLUGIN, GsdApportPluginClass))
+
+typedef struct GsdApportPluginPrivate GsdApportPluginPrivate;
+
+typedef struct {
+        GnomeSettingsPlugin		 parent;
+        GsdApportPluginPrivate     *priv;
+} GsdApportPlugin;
+
+typedef struct {
+        GnomeSettingsPluginClass parent_class;
+} GsdApportPluginClass;
+
+GType   gsd_apport_plugin_get_type		(void) G_GNUC_CONST;
+
+/* All the plugins must implement this function */
+G_MODULE_EXPORT GType register_gnome_settings_plugin	(GTypeModule *module);
+
+G_END_DECLS
+
+#endif /* __GSD_APPORT_PLUGIN_H__ */
diff -Naur gnome-settings-daemon-2.23.4_old/plugins/apport/Makefile.am gnome-settings-daemon-2.23.4/plugins/apport/Makefile.am
--- gnome-settings-daemon-2.23.4_old/plugins/apport/Makefile.am	1970-01-01 03:00:00.000000000 +0300
+++ gnome-settings-daemon-2.23.4/plugins/apport/Makefile.am	2008-07-25 18:15:29.000000000 +0400
@@ -0,0 +1,56 @@
+noinst_PROGRAMS = 			\
+	test-apport 			\
+	$(NULL)
+
+test_apport_SOURCES = 		\
+	test-apport.c       		\
+	gsd-apport-manager.h	\
+	gsd-apport-manager.c	\
+	$(NULL)
+
+test_apport_CPPFLAGS = \
+	-I$(top_srcdir)/gnome-settings-daemon		\
+	-DGNOME_SETTINGS_LOCALEDIR=\""$(datadir)/locale"\" \
+	$(AM_CPPFLAGS)
+
+test_apport_CFLAGS = \
+	$(SETTINGS_PLUGIN_CFLAGS)	\
+	$(AM_CFLAGS)
+
+test_apport_LDADD =		\
+	$(top_builddir)/gnome-settings-daemon/libgsd-profile.la	\
+	$(SETTINGS_PLUGIN_LIBS)	\
+	$(NULL)
+
+plugin_LTLIBRARIES = libapport.la
+
+libapport_la_SOURCES = 		\
+	gsd-apport-manager.c	\
+	gsd-apport-manager.h	\
+	gsd-apport-plugin.c	\
+	gsd-apport-plugin.h
+
+libapport_la_CPPFLAGS = 					\
+	-I$(top_srcdir)/gnome-settings-daemon			\
+	-DGNOME_SETTINGS_LOCALEDIR=\""$(datadir)/locale"\"	\
+	$(AM_CPPFLAGS)
+
+libapport_la_CFLAGS = 		\
+	$(SETTINGS_PLUGIN_CFLAGS)	\
+	$(AM_CFLAGS)
+
+libapport_la_LDFLAGS = $(GSD_PLUGIN_LDFLAGS)
+
+libapport_la_LIBADD = $(SETTINGS_PLUGIN_LIBS)
+
+plugin_in_files = apport.gnome-settings-plugin.in
+
+plugin_DATA = $(plugin_in_files:.gnome-settings-plugin.in=.gnome-settings-plugin)
+
+EXTRA_DIST = $(plugin_in_files)
+
+CLEANFILES = $(plugin_DATA)
+
+DISTCLEANFILES = (plugin_DATA)
+
+@GSD_INTLTOOL_PLUGIN_RULE@
diff -Naur gnome-settings-daemon-2.23.4_old/plugins/apport/test-apport.c gnome-settings-daemon-2.23.4/plugins/apport/test-apport.c
--- gnome-settings-daemon-2.23.4_old/plugins/apport/test-apport.c	1970-01-01 03:00:00.000000000 +0300
+++ gnome-settings-daemon-2.23.4/plugins/apport/test-apport.c	2008-07-25 18:15:29.000000000 +0400
@@ -0,0 +1,59 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2008 Nikolay Derkach <nderkach@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#include "config.h"
+
+#include <stdlib.h>
+#include <libintl.h>
+#include <locale.h>
+#include <string.h>
+#include <unistd.h>
+
+#include <glib/gi18n.h>
+#include <gtk/gtk.h>
+
+#include "gsd-apport-manager.h"
+
+static gboolean
+idle (GsdApportManager *manager)
+{
+        gsd_apport_manager_start (manager, NULL);
+        return FALSE;
+}
+
+int
+main (int argc, char *argv[])
+{
+        GsdApportManager *manager;
+
+        bindtextdomain (GETTEXT_PACKAGE, GNOME_SETTINGS_LOCALEDIR);
+        bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
+        textdomain (GETTEXT_PACKAGE);
+
+        setlocale (LC_ALL, "");
+
+        gtk_init (&argc, &argv);
+
+        manager = gsd_apport_manager_new ();
+        g_idle_add ((GSourceFunc)idle, manager);
+
+        gtk_main ();
+
+        return 0;
+}
diff -Naur gnome-settings-daemon-2.23.4_old/plugins/Makefile.am gnome-settings-daemon-2.23.4/plugins/Makefile.am
--- gnome-settings-daemon-2.23.4_old/plugins/Makefile.am	2008-04-21 14:23:15.000000000 +0400
+++ gnome-settings-daemon-2.23.4/plugins/Makefile.am	2008-07-25 18:18:28.000000000 +0400
@@ -3,6 +3,7 @@
 SUBDIRS =		\
 	common		\
 	a11y-keyboard	\
+	apport      \
 	background	\
 	clipboard	\
 	dummy		\