From f688ea05957317fe28e85619a3059c2060a0edff Mon Sep 17 00:00:00 2001
From: Dirk Mueller <dmueller@suse.com>
Date: Fri, 7 Sep 2012 15:42:48 +0200
Subject: [PATCH] remove drivers that do not exist and do not build on ARM
 (default)

---
 config/armv7hl/default | 237 +++++++++----------------------------------------
 1 Datei geändert, 41 Zeilen hinzugefügt(+), 196 Zeilen entfernt(-)

diff --git a/config/armv7hl/default b/config/armv7hl/default
index 38ef503..4f0e2c2 100644
--- a/config/armv7hl/default
+++ b/config/armv7hl/default
@@ -1,6 +1,6 @@
 #
 # Automatically generated file; DO NOT EDIT.
-# Linux/arm 3.6.0-rc3 Kernel Configuration
+# Linux/arm 3.6.0-rc4 Kernel Configuration
 #
 CONFIG_ARM=y
 CONFIG_MIGHT_HAVE_PCI=y
@@ -1038,7 +1038,6 @@ CONFIG_CAN_VCAN=m
 CONFIG_CAN_SLCAN=m
 CONFIG_CAN_DEV=m
 CONFIG_CAN_CALC_BITTIMING=y
-CONFIG_CAN_MCP251X=m
 CONFIG_PCH_CAN=m
 CONFIG_CAN_SJA1000=m
 CONFIG_CAN_SJA1000_ISA=m
@@ -1228,8 +1227,7 @@ CONFIG_EXTRA_FIRMWARE=""
 # CONFIG_SYS_HYPERVISOR is not set
 # CONFIG_GENERIC_CPU_DEVICES is not set
 CONFIG_REGMAP=y
-CONFIG_REGMAP_I2C=y
-CONFIG_REGMAP_SPI=y
+CONFIG_REGMAP_I2C=m
 CONFIG_REGMAP_IRQ=y
 CONFIG_DMA_SHARED_BUFFER=y
 CONFIG_CONNECTOR=y
@@ -1316,12 +1314,6 @@ CONFIG_MTD_LATCH_ADDR=m
 CONFIG_MTD_PMC551=m
 CONFIG_MTD_PMC551_BUGFIX=y
 # CONFIG_MTD_PMC551_DEBUG is not set
-CONFIG_MTD_DATAFLASH=m
-CONFIG_MTD_DATAFLASH_WRITE_VERIFY=y
-CONFIG_MTD_DATAFLASH_OTP=y
-CONFIG_MTD_M25P80=m
-CONFIG_M25PXX_USE_FAST_READ=y
-CONFIG_MTD_SST25L=m
 CONFIG_MTD_SLRAM=m
 CONFIG_MTD_PHRAM=m
 CONFIG_MTD_MTDRAM=m
@@ -1394,7 +1386,7 @@ CONFIG_OF_EARLY_FLATTREE=y
 CONFIG_OF_ADDRESS=y
 CONFIG_OF_IRQ=y
 CONFIG_OF_DEVICE=y
-CONFIG_OF_I2C=y
+CONFIG_OF_I2C=m
 CONFIG_OF_NET=y
 CONFIG_OF_MDIO=y
 CONFIG_OF_PCI=y
@@ -1476,7 +1468,6 @@ CONFIG_BLK_DEV_RBD=m
 CONFIG_SENSORS_LIS3LV02D=m
 CONFIG_AD525X_DPOT=m
 CONFIG_AD525X_DPOT_I2C=m
-CONFIG_AD525X_DPOT_SPI=m
 # CONFIG_ATMEL_PWM is not set
 CONFIG_PHANTOM=m
 CONFIG_SGI_IOC4=m
@@ -1494,10 +1485,8 @@ CONFIG_SENSORS_BH1770=m
 CONFIG_SENSORS_APDS990X=m
 CONFIG_HMC6352=m
 CONFIG_DS1682=m
-CONFIG_TI_DAC7512=m
 CONFIG_ARM_CHARLCD=y
 # CONFIG_BMP085_I2C is not set
-# CONFIG_BMP085_SPI is not set
 CONFIG_PCH_PHUB=m
 CONFIG_USB_SWITCH_FSA9480=m
 CONFIG_C2PORT=m
@@ -1506,11 +1495,9 @@ CONFIG_C2PORT=m
 # EEPROM support
 #
 CONFIG_EEPROM_AT24=m
-CONFIG_EEPROM_AT25=m
 CONFIG_EEPROM_LEGACY=m
 CONFIG_EEPROM_MAX6875=m
 CONFIG_EEPROM_93CX6=m
-CONFIG_EEPROM_93XX46=m
 CONFIG_CB710_CORE=m
 # CONFIG_CB710_DEBUG is not set
 CONFIG_CB710_DEBUG_ASSUMPTIONS=y
@@ -1519,7 +1506,6 @@ CONFIG_CB710_DEBUG_ASSUMPTIONS=y
 # Texas Instruments shared transport line discipline
 #
 CONFIG_TI_ST=m
-CONFIG_SENSORS_LIS3_SPI=m
 CONFIG_SENSORS_LIS3_I2C=m
 
 #
@@ -1829,7 +1815,6 @@ CONFIG_MII=y
 CONFIG_IEEE802154_DRIVERS=m
 CONFIG_IEEE802154_FAKEHARD=m
 # CONFIG_IEEE802154_FAKELB is not set
-CONFIG_IEEE802154_AT86RF230=m
 CONFIG_IFB=m
 CONFIG_NET_TEAM=m
 CONFIG_NET_TEAM_MODE_BROADCAST=m
@@ -2001,12 +1986,8 @@ CONFIG_MLX4_CORE=m
 CONFIG_MLX4_DEBUG=y
 CONFIG_NET_VENDOR_MICREL=y
 CONFIG_KS8842=m
-CONFIG_KS8851=m
 CONFIG_KS8851_MLL=m
 CONFIG_KSZ884X_PCI=m
-CONFIG_NET_VENDOR_MICROCHIP=y
-CONFIG_ENC28J60=m
-# CONFIG_ENC28J60_WRITEVERIFY is not set
 CONFIG_NET_VENDOR_MYRI=y
 CONFIG_MYRI10GE=m
 CONFIG_FEALNX=m
@@ -2109,7 +2090,6 @@ CONFIG_MDIO_BITBANG=m
 CONFIG_MDIO_GPIO=m
 CONFIG_MDIO_BUS_MUX=m
 CONFIG_MDIO_BUS_MUX_GPIO=m
-CONFIG_MICREL_KS8995MA=m
 CONFIG_PLIP=m
 CONFIG_PPP=m
 CONFIG_PPP_BSDCOMP=m
@@ -2239,7 +2219,6 @@ CONFIG_IWL3945=m
 CONFIG_LIBERTAS=m
 CONFIG_LIBERTAS_USB=m
 CONFIG_LIBERTAS_SDIO=m
-CONFIG_LIBERTAS_SPI=m
 # CONFIG_LIBERTAS_DEBUG is not set
 CONFIG_LIBERTAS_MESH=y
 CONFIG_HERMES=m
@@ -2252,8 +2231,6 @@ CONFIG_ORINOCO_USB=m
 CONFIG_P54_COMMON=m
 CONFIG_P54_USB=m
 CONFIG_P54_PCI=m
-CONFIG_P54_SPI=m
-# CONFIG_P54_SPI_DEFAULT_EEPROM is not set
 CONFIG_P54_LEDS=y
 CONFIG_RT2X00=m
 CONFIG_RT2400PCI=m
@@ -2474,7 +2451,6 @@ CONFIG_INPUT_EVDEV=y
 # Input Device Drivers
 #
 CONFIG_INPUT_KEYBOARD=y
-CONFIG_KEYBOARD_ADP5520=m
 CONFIG_KEYBOARD_ADP5588=m
 CONFIG_KEYBOARD_ADP5589=m
 CONFIG_KEYBOARD_ATKBD=y
@@ -2495,7 +2471,6 @@ CONFIG_KEYBOARD_OPENCORES=m
 CONFIG_KEYBOARD_SAMSUNG=m
 # CONFIG_KEYBOARD_STOWAWAY is not set
 CONFIG_KEYBOARD_SUNKBD=m
-CONFIG_KEYBOARD_STMPE=m
 CONFIG_KEYBOARD_OMAP4=m
 CONFIG_KEYBOARD_XTKBD=m
 CONFIG_INPUT_MOUSE=y
@@ -2553,18 +2528,14 @@ CONFIG_TABLET_USB_HANWANG=m
 CONFIG_TABLET_USB_KBTAB=m
 CONFIG_TABLET_USB_WACOM=m
 CONFIG_INPUT_TOUCHSCREEN=y
-CONFIG_TOUCHSCREEN_ADS7846=m
-CONFIG_TOUCHSCREEN_AD7877=m
 CONFIG_TOUCHSCREEN_AD7879=m
 CONFIG_TOUCHSCREEN_AD7879_I2C=m
-CONFIG_TOUCHSCREEN_AD7879_SPI=m
 CONFIG_TOUCHSCREEN_ATMEL_MXT=m
 CONFIG_TOUCHSCREEN_AUO_PIXCIR=m
 CONFIG_TOUCHSCREEN_BU21013=m
 CONFIG_TOUCHSCREEN_CY8CTMG110=m
 CONFIG_TOUCHSCREEN_CYTTSP_CORE=m
 CONFIG_TOUCHSCREEN_CYTTSP_I2C=m
-CONFIG_TOUCHSCREEN_CYTTSP_SPI=m
 CONFIG_TOUCHSCREEN_DYNAPRO=m
 CONFIG_TOUCHSCREEN_HAMPSHIRE=m
 # CONFIG_TOUCHSCREEN_EETI is not set
@@ -2588,7 +2559,6 @@ CONFIG_TOUCHSCREEN_TOUCHRIGHT=m
 CONFIG_TOUCHSCREEN_TOUCHWIN=m
 CONFIG_TOUCHSCREEN_UCB1400=m
 CONFIG_TOUCHSCREEN_PIXCIR=m
-CONFIG_TOUCHSCREEN_WM831X=m
 CONFIG_TOUCHSCREEN_WM97XX=m
 CONFIG_TOUCHSCREEN_WM9705=y
 CONFIG_TOUCHSCREEN_WM9712=y
@@ -2614,17 +2584,13 @@ CONFIG_TOUCHSCREEN_USB_NEXIO=y
 CONFIG_TOUCHSCREEN_USB_EASYTOUCH=y
 CONFIG_TOUCHSCREEN_TOUCHIT213=m
 # CONFIG_TOUCHSCREEN_TSC_SERIO is not set
-CONFIG_TOUCHSCREEN_TSC2005=m
 CONFIG_TOUCHSCREEN_TSC2007=m
 CONFIG_TOUCHSCREEN_W90X900=m
 CONFIG_TOUCHSCREEN_ST1232=m
-CONFIG_TOUCHSCREEN_STMPE=m
 CONFIG_TOUCHSCREEN_TPS6507X=m
 CONFIG_INPUT_MISC=y
-CONFIG_INPUT_88PM80X_ONKEY=m
 CONFIG_INPUT_AD714X=m
 CONFIG_INPUT_AD714X_I2C=m
-CONFIG_INPUT_AD714X_SPI=m
 # CONFIG_INPUT_BMA150 is not set
 CONFIG_INPUT_MMA8450=m
 CONFIG_INPUT_MPU3050=m
@@ -2640,10 +2606,8 @@ CONFIG_INPUT_CM109=m
 CONFIG_INPUT_UINPUT=m
 CONFIG_INPUT_PCF8574=m
 CONFIG_INPUT_GPIO_ROTARY_ENCODER=m
-CONFIG_INPUT_WM831X_ON=m
 CONFIG_INPUT_ADXL34X=m
 CONFIG_INPUT_ADXL34X_I2C=m
-CONFIG_INPUT_ADXL34X_SPI=m
 CONFIG_INPUT_CMA3000=m
 CONFIG_INPUT_CMA3000_I2C=m
 
@@ -2711,9 +2675,6 @@ CONFIG_SERIAL_8250_RUNTIME_UARTS=32
 # Non-8250 serial port support
 #
 CONFIG_SERIAL_AMBA_PL011=m
-# CONFIG_SERIAL_MAX3100 is not set
-CONFIG_SERIAL_MAX3107=m
-CONFIG_SERIAL_MRST_MAX3110=m
 CONFIG_SERIAL_MFD_HSU=m
 # CONFIG_SERIAL_UARTLITE is not set
 CONFIG_SERIAL_CORE=y
@@ -2726,7 +2687,6 @@ CONFIG_SERIAL_ALTERA_JTAGUART=m
 CONFIG_SERIAL_ALTERA_UART=m
 CONFIG_SERIAL_ALTERA_UART_MAXPORTS=4
 CONFIG_SERIAL_ALTERA_UART_BAUDRATE=115200
-CONFIG_SERIAL_IFX6X60=m
 CONFIG_SERIAL_PCH_UART=m
 CONFIG_SERIAL_XILINX_PS_UART=m
 CONFIG_PRINTER=m
@@ -2756,22 +2716,20 @@ CONFIG_TCG_TPM=m
 CONFIG_TCG_ATMEL=m
 CONFIG_DEVPORT=y
 CONFIG_CRASHER=m
-CONFIG_I2C=y
+CONFIG_I2C=m
 CONFIG_I2C_BOARDINFO=y
-CONFIG_I2C_COMPAT=y
-CONFIG_I2C_CHARDEV=m
-CONFIG_I2C_MUX=m
+# CONFIG_I2C_COMPAT is not set
+# CONFIG_I2C_CHARDEV is not set
+# CONFIG_I2C_MUX is not set
+# CONFIG_I2C_HELPER_AUTO is not set
+# CONFIG_I2C_SMBUS is not set
 
 #
-# Multiplexer I2C Chip support
+# I2C Algorithms
 #
-CONFIG_I2C_MUX_GPIO=m
-CONFIG_I2C_MUX_PCA9541=m
-CONFIG_I2C_MUX_PCA954x=m
-CONFIG_I2C_HELPER_AUTO=y
-CONFIG_I2C_SMBUS=m
 CONFIG_I2C_ALGOBIT=m
-CONFIG_I2C_ALGOPCA=m
+# CONFIG_I2C_ALGOPCF is not set
+# CONFIG_I2C_ALGOPCA is not set
 
 #
 # I2C Hardware Bus support
@@ -2780,32 +2738,32 @@ CONFIG_I2C_ALGOPCA=m
 #
 # PC SMBus host controller drivers
 #
-CONFIG_I2C_ALI1535=m
-CONFIG_I2C_ALI1563=m
-CONFIG_I2C_ALI15X3=m
-CONFIG_I2C_AMD756=m
-CONFIG_I2C_AMD8111=m
-CONFIG_I2C_I801=m
-CONFIG_I2C_ISCH=m
-CONFIG_I2C_PIIX4=m
-CONFIG_I2C_NFORCE2=m
-CONFIG_I2C_SIS5595=m
-CONFIG_I2C_SIS630=m
-CONFIG_I2C_SIS96X=m
-CONFIG_I2C_VIA=m
-CONFIG_I2C_VIAPRO=m
+# CONFIG_I2C_ALI1535 is not set
+# CONFIG_I2C_ALI1563 is not set
+# CONFIG_I2C_ALI15X3 is not set
+# CONFIG_I2C_AMD756 is not set
+# CONFIG_I2C_AMD8111 is not set
+# CONFIG_I2C_I801 is not set
+# CONFIG_I2C_ISCH is not set
+# CONFIG_I2C_PIIX4 is not set
+# CONFIG_I2C_NFORCE2 is not set
+# CONFIG_I2C_SIS5595 is not set
+# CONFIG_I2C_SIS630 is not set
+# CONFIG_I2C_SIS96X is not set
+# CONFIG_I2C_VIA is not set
+# CONFIG_I2C_VIAPRO is not set
 
 #
 # I2C system bus drivers (mostly embedded / system-on-chip)
 #
 # CONFIG_I2C_DESIGNWARE_PLATFORM is not set
 # CONFIG_I2C_DESIGNWARE_PCI is not set
-CONFIG_I2C_EG20T=m
-CONFIG_I2C_GPIO=m
-CONFIG_I2C_INTEL_MID=m
-CONFIG_I2C_NOMADIK=m
-CONFIG_I2C_OCORES=m
-CONFIG_I2C_PCA_PLATFORM=m
+# CONFIG_I2C_EG20T is not set
+# CONFIG_I2C_GPIO is not set
+# CONFIG_I2C_INTEL_MID is not set
+# CONFIG_I2C_NOMADIK is not set
+# CONFIG_I2C_OCORES is not set
+# CONFIG_I2C_PCA_PLATFORM is not set
 # CONFIG_I2C_PXA_PCI is not set
 # CONFIG_I2C_SIMTEC is not set
 CONFIG_I2C_VERSATILE=m
@@ -2814,46 +2772,20 @@ CONFIG_I2C_VERSATILE=m
 #
 # External I2C/SMBus adapter drivers
 #
-CONFIG_I2C_DIOLAN_U2C=m
-CONFIG_I2C_PARPORT=m
-CONFIG_I2C_PARPORT_LIGHT=m
-CONFIG_I2C_TAOS_EVM=m
-CONFIG_I2C_TINY_USB=m
+# CONFIG_I2C_DIOLAN_U2C is not set
+# CONFIG_I2C_PARPORT is not set
+# CONFIG_I2C_PARPORT_LIGHT is not set
+# CONFIG_I2C_TAOS_EVM is not set
+# CONFIG_I2C_TINY_USB is not set
 
 #
 # Other I2C/SMBus bus drivers
 #
-CONFIG_I2C_STUB=m
+# CONFIG_I2C_STUB is not set
 # CONFIG_I2C_DEBUG_CORE is not set
 # CONFIG_I2C_DEBUG_ALGO is not set
 # CONFIG_I2C_DEBUG_BUS is not set
-CONFIG_SPI=y
-# CONFIG_SPI_DEBUG is not set
-CONFIG_SPI_MASTER=y
-
-#
-# SPI Master Controller Drivers
-#
-CONFIG_SPI_ALTERA=m
-CONFIG_SPI_BITBANG=m
-CONFIG_SPI_BUTTERFLY=m
-CONFIG_SPI_GPIO=m
-CONFIG_SPI_LM70_LLP=m
-CONFIG_SPI_OC_TINY=m
-CONFIG_SPI_PL022=m
-# CONFIG_SPI_PXA2XX_PCI is not set
-CONFIG_SPI_TOPCLIFF_PCH=m
-CONFIG_SPI_XCOMM=m
-# CONFIG_SPI_XILINX is not set
-CONFIG_SPI_DESIGNWARE=y
-CONFIG_SPI_DW_PCI=m
-CONFIG_SPI_DW_MMIO=m
-
-#
-# SPI Protocol Masters
-#
-CONFIG_SPI_SPIDEV=m
-CONFIG_SPI_TLE62X0=m
+# CONFIG_SPI is not set
 # CONFIG_HSI is not set
 
 #
@@ -2896,7 +2828,7 @@ CONFIG_GPIO_MAX730X=m
 # Memory mapped GPIO drivers:
 #
 CONFIG_GPIO_GENERIC_PLATFORM=m
-CONFIG_GPIO_EM=m
+# CONFIG_GPIO_EM is not set
 CONFIG_GPIO_PL061=y
 CONFIG_GPIO_VX855=m
 
@@ -2907,10 +2839,6 @@ CONFIG_GPIO_ARIZONA=m
 CONFIG_GPIO_MAX7300=m
 CONFIG_GPIO_MAX732X=m
 CONFIG_GPIO_PCF857X=m
-# CONFIG_GPIO_SX150X is not set
-CONFIG_GPIO_STMPE=y
-CONFIG_GPIO_WM831X=m
-CONFIG_GPIO_ADP5520=m
 CONFIG_GPIO_ADP5588=m
 
 #
@@ -2924,10 +2852,7 @@ CONFIG_GPIO_RDC321X=m
 #
 # SPI GPIO expanders:
 #
-CONFIG_GPIO_MAX7301=m
 CONFIG_GPIO_MCP23S08=m
-CONFIG_GPIO_MC33880=m
-CONFIG_GPIO_74X164=m
 
 #
 # AC97 GPIO expanders:
@@ -2968,8 +2893,6 @@ CONFIG_POWER_SUPPLY=y
 # CONFIG_POWER_SUPPLY_DEBUG is not set
 CONFIG_PDA_POWER=m
 CONFIG_APM_POWER=m
-CONFIG_WM831X_BACKUP=m
-CONFIG_WM831X_POWER=m
 # CONFIG_TEST_POWER is not set
 CONFIG_BATTERY_DS2760=m
 CONFIG_BATTERY_DS2780=m
@@ -2995,10 +2918,8 @@ CONFIG_HWMON_VID=m
 #
 # Native drivers
 #
-# CONFIG_SENSORS_AD7314 is not set
 CONFIG_SENSORS_AD7414=m
 CONFIG_SENSORS_AD7418=m
-CONFIG_SENSORS_ADCXX=m
 CONFIG_SENSORS_ADM1021=m
 CONFIG_SENSORS_ADM1025=m
 CONFIG_SENSORS_ADM1026=m
@@ -3028,7 +2949,6 @@ CONFIG_SENSORS_IT87=m
 CONFIG_SENSORS_JC42=m
 CONFIG_SENSORS_LINEAGE=m
 CONFIG_SENSORS_LM63=m
-CONFIG_SENSORS_LM70=m
 CONFIG_SENSORS_LM73=m
 CONFIG_SENSORS_LM75=m
 CONFIG_SENSORS_LM77=m
@@ -3046,7 +2966,6 @@ CONFIG_SENSORS_LTC4245=m
 CONFIG_SENSORS_LTC4261=m
 CONFIG_SENSORS_LM95241=m
 CONFIG_SENSORS_LM95245=m
-CONFIG_SENSORS_MAX1111=m
 CONFIG_SENSORS_MAX16065=m
 CONFIG_SENSORS_MAX1619=m
 CONFIG_SENSORS_MAX1668=m
@@ -3085,7 +3004,6 @@ CONFIG_SENSORS_SCH5627=m
 CONFIG_SENSORS_SCH5636=m
 CONFIG_SENSORS_ADS1015=m
 CONFIG_SENSORS_ADS7828=m
-CONFIG_SENSORS_ADS7871=m
 CONFIG_SENSORS_AMC6821=m
 # CONFIG_SENSORS_INA2XX is not set
 CONFIG_SENSORS_THMC50=m
@@ -3105,7 +3023,6 @@ CONFIG_SENSORS_W83L785TS=m
 CONFIG_SENSORS_W83L786NG=m
 CONFIG_SENSORS_W83627HF=m
 CONFIG_SENSORS_W83627EHF=m
-CONFIG_SENSORS_WM831X=m
 CONFIG_THERMAL=m
 CONFIG_THERMAL_HWMON=y
 CONFIG_WATCHDOG=y
@@ -3116,7 +3033,6 @@ CONFIG_WATCHDOG_CORE=y
 # Watchdog Device Drivers
 #
 CONFIG_SOFT_WATCHDOG=m
-CONFIG_WM831X_WATCHDOG=m
 CONFIG_ARM_SP805_WATCHDOG=m
 CONFIG_DW_WATCHDOG=m
 CONFIG_MAX63XX_WATCHDOG=m
@@ -3163,65 +3079,28 @@ CONFIG_BCMA_DRIVER_GMAC_CMN=y
 # Multifunction device drivers
 #
 CONFIG_MFD_CORE=y
-# CONFIG_MFD_88PM860X is not set
-CONFIG_MFD_88PM800=m
-CONFIG_MFD_88PM805=m
 CONFIG_MFD_SM501=m
 CONFIG_MFD_SM501_GPIO=y
 CONFIG_MFD_ASIC3=y
 CONFIG_HTC_EGPIO=y
 CONFIG_HTC_PASIC3=m
-# CONFIG_HTC_I2CPLD is not set
 CONFIG_UCB1400_CORE=m
 # CONFIG_MFD_LM3533 is not set
 CONFIG_TPS6105X=m
 CONFIG_TPS65010=m
 CONFIG_TPS6507X=m
 CONFIG_MFD_TPS65217=m
-# CONFIG_MFD_TPS6586X is not set
-# CONFIG_MFD_TPS65910 is not set
-# CONFIG_MFD_TPS65912_I2C is not set
-# CONFIG_MFD_TPS65912_SPI is not set
-# CONFIG_TWL4030_CORE is not set
-# CONFIG_TWL6040_CORE is not set
-CONFIG_MFD_STMPE=y
-
-#
-# STMPE Interface Drivers
-#
-CONFIG_STMPE_I2C=y
-CONFIG_STMPE_SPI=y
-# CONFIG_MFD_TC3589X is not set
 CONFIG_MFD_TMIO=y
 CONFIG_MFD_T7L66XB=y
 CONFIG_MFD_TC6387XB=y
 CONFIG_MFD_TC6393XB=y
-# CONFIG_PMIC_DA903X is not set
-# CONFIG_MFD_DA9052_SPI is not set
-# CONFIG_MFD_DA9052_I2C is not set
-CONFIG_PMIC_ADP5520=y
-CONFIG_MFD_MAX77686=y
-# CONFIG_MFD_MAX77693 is not set
-# CONFIG_MFD_MAX8925 is not set
-# CONFIG_MFD_MAX8997 is not set
-# CONFIG_MFD_MAX8998 is not set
-# CONFIG_MFD_SEC_CORE is not set
 CONFIG_MFD_ARIZONA=y
 CONFIG_MFD_ARIZONA_I2C=m
-CONFIG_MFD_ARIZONA_SPI=m
 # CONFIG_MFD_WM5102 is not set
 # CONFIG_MFD_WM5110 is not set
-# CONFIG_MFD_WM8400 is not set
-CONFIG_MFD_WM831X=y
-# CONFIG_MFD_WM831X_I2C is not set
-CONFIG_MFD_WM831X_SPI=y
-# CONFIG_MFD_WM8350_I2C is not set
-# CONFIG_MFD_WM8994 is not set
 # CONFIG_MFD_PCF50633 is not set
-# CONFIG_MFD_MC13XXX_SPI is not set
 # CONFIG_MFD_MC13XXX_I2C is not set
 # CONFIG_ABX500_CORE is not set
-# CONFIG_EZX_PCAP is not set
 CONFIG_MFD_TIMBERDALE=m
 CONFIG_LPC_SCH=m
 # CONFIG_LPC_ICH is not set
@@ -3229,10 +3108,6 @@ CONFIG_MFD_RDC321X=m
 # CONFIG_MFD_JANZ_CMODIO is not set
 CONFIG_MFD_VX855=m
 CONFIG_MFD_WL1273_CORE=m
-# CONFIG_MFD_TPS65090 is not set
-# CONFIG_MFD_AAT2870_CORE is not set
-# CONFIG_MFD_RC5T583 is not set
-# CONFIG_MFD_PALMAS is not set
 CONFIG_REGULATOR=y
 # CONFIG_REGULATOR_DEBUG is not set
 CONFIG_REGULATOR_DUMMY=y
@@ -3247,17 +3122,13 @@ CONFIG_REGULATOR_MAX1586=m
 CONFIG_REGULATOR_MAX8649=m
 CONFIG_REGULATOR_MAX8660=m
 CONFIG_REGULATOR_MAX8952=m
-CONFIG_REGULATOR_MAX77686=m
 CONFIG_REGULATOR_LP3971=m
 CONFIG_REGULATOR_LP3972=m
-CONFIG_REGULATOR_LP872X=y
 CONFIG_REGULATOR_TPS6105X=m
 CONFIG_REGULATOR_TPS62360=m
 CONFIG_REGULATOR_TPS65023=m
 CONFIG_REGULATOR_TPS6507X=m
 CONFIG_REGULATOR_TPS65217=m
-CONFIG_REGULATOR_TPS6524X=m
-CONFIG_REGULATOR_WM831X=m
 CONFIG_MEDIA_SUPPORT=m
 
 #
@@ -3963,21 +3834,10 @@ CONFIG_FB_BROADSHEET=m
 # CONFIG_EXYNOS_VIDEO is not set
 CONFIG_BACKLIGHT_LCD_SUPPORT=y
 CONFIG_LCD_CLASS_DEVICE=m
-CONFIG_LCD_L4F00242T03=m
-CONFIG_LCD_LMS283GF05=m
-CONFIG_LCD_LTV350QV=m
-CONFIG_LCD_ILI9320=m
-CONFIG_LCD_TDO24M=m
-CONFIG_LCD_VGG2432A4=m
 CONFIG_LCD_PLATFORM=m
-CONFIG_LCD_S6E63M0=m
-CONFIG_LCD_LD9040=m
-CONFIG_LCD_AMS369FG06=m
 CONFIG_BACKLIGHT_CLASS_DEVICE=y
 CONFIG_BACKLIGHT_GENERIC=m
 CONFIG_BACKLIGHT_PWM=m
-CONFIG_BACKLIGHT_WM831X=m
-CONFIG_BACKLIGHT_ADP5520=m
 CONFIG_BACKLIGHT_ADP8860=m
 CONFIG_BACKLIGHT_ADP8870=m
 CONFIG_BACKLIGHT_LP855X=m
@@ -4151,7 +4011,6 @@ CONFIG_SND_VX222=m
 CONFIG_SND_YMFPCI=m
 CONFIG_SND_ARM=y
 CONFIG_SND_ARMAACI=m
-CONFIG_SND_SPI=y
 CONFIG_SND_USB=y
 CONFIG_SND_USB_AUDIO=m
 CONFIG_SND_USB_UA101=m
@@ -4558,12 +4417,9 @@ CONFIG_LEDS_LP5521=m
 CONFIG_LEDS_LP5523=m
 CONFIG_LEDS_PCA955X=m
 CONFIG_LEDS_PCA9633=m
-CONFIG_LEDS_WM831X_STATUS=m
-CONFIG_LEDS_DAC124S085=m
 CONFIG_LEDS_REGULATOR=m
 CONFIG_LEDS_BD2802=m
 CONFIG_LEDS_LT3593=m
-CONFIG_LEDS_ADP5520=m
 CONFIG_LEDS_ASIC3=y
 # CONFIG_LEDS_RENESAS_TPU is not set
 CONFIG_LEDS_TCA6507=m
@@ -4629,7 +4485,6 @@ CONFIG_RTC_INTF_DEV=y
 #
 # I2C RTC drivers
 #
-CONFIG_RTC_DRV_88PM80X=m
 CONFIG_RTC_DRV_DS1307=m
 CONFIG_RTC_DRV_DS1374=m
 CONFIG_RTC_DRV_DS1672=m
@@ -4654,15 +4509,6 @@ CONFIG_RTC_DRV_RV3029C2=m
 #
 # SPI RTC drivers
 #
-CONFIG_RTC_DRV_M41T93=m
-CONFIG_RTC_DRV_M41T94=m
-CONFIG_RTC_DRV_DS1305=m
-CONFIG_RTC_DRV_DS1390=m
-CONFIG_RTC_DRV_MAX6902=m
-CONFIG_RTC_DRV_R9701=m
-CONFIG_RTC_DRV_RS5C348=m
-CONFIG_RTC_DRV_DS3234=m
-CONFIG_RTC_DRV_PCF2123=m
 
 #
 # Platform RTC drivers
@@ -4680,7 +4526,6 @@ CONFIG_RTC_DRV_MSM6242=m
 CONFIG_RTC_DRV_BQ4802=m
 CONFIG_RTC_DRV_RP5C01=m
 CONFIG_RTC_DRV_V3020=m
-CONFIG_RTC_DRV_WM831X=m
 
 #
 # on-CPU RTC drivers
@@ -4773,7 +4618,7 @@ CONFIG_SBE_PMCC4_NCOMM=y
 CONFIG_FB_XGI=m
 CONFIG_SBE_2T3E3=m
 CONFIG_USB_ENESTORAGE=m
-CONFIG_BCM_WIMAX=m
+# CONFIG_BCM_WIMAX is not set
 CONFIG_FT1000=m
 CONFIG_FT1000_USB=m
 
-- 
1.7.11.5